
# $k = 11.11111;
# $m = 1.0;
# $b = 2.66667;

$fext = 0.0;
$m = 0.001;
$b = 0.002;
$k = 0.008;
$dt = 1/30.0;

$k1 = 2.0 - $dt*($k*$dt + $b)/$m; 
$k2 = 1.0 - $dt*$b/$m; 
$k3 = $dt*$dt/$m;

# x_{t+1} = k1 * x_t - k2 * x_{t-1} + k3
# t_0 = 0

# En el tiempo t = 0
$xt_1 = 0;
$xt   = 0;
$xt1  = 0;
$t = 0;
print "$t $xt\n";

$Dt2m = 0.1 * $k * $dt * $dt/$m;

$error_previo = 0;
$Kp = 0.8;
$Kd = 0.02;
FIN: for ( $i=1; ; $i++ ) {

	$xt1 = $k1*$xt - $k2*$xt_1 + $fext*$k3;
	$xt_1 = $xt;
	$xt   = $xt1;

	$t = $i*$dt;

	if( $t > 5.0 && $t <= 11 ) {
		$y = sin( 3.1416*($t - 5.0)/4.0 ); 

		$error = $y - $xt1;

    	$derivativo = ($error - $error_previo)/$dt;
		$fext = $Kp*$error + $Kd*$derivativo;
		$error_previo = $error;
	}
	else {
		$fext = 0;
		$error_previo = 0;
	}
	print "$t $xt1\n";

	last FIN if ( $t > 20.0 );
}

